ProgramFile
! cRobot 'DB500'
! Example program to demonstrate 
! the functions GOTO, WHILE and IF THEN ELSE
!
! Below section is called once at t=0
! Add Initialization commands here
! 
EndInit
! 
! Below section is called at t>0
! Add new ERPL / ERCL commands here
! 
! Set Default SPEEDs and ACCELs
SPEED_PTP_AX    20.0000    20.0000    20.0000    20.0000    20.0000    20.0000
ACCEL_PTP_AX    40.0000    40.0000    40.0000    40.0000    40.0000    40.0000
SPEED_CP         0.1000 0.0
ACCEL_CP         0.2000
SPEED_ORI       20.0000 0.0
ACCEL_ORI       40.0000
OV_PRO         100.0000
ERC NO_DECEL OFF
ZONE             0.0000
! ---------

!GOTO LABEL ende
!GOTO LABEL COLLISION

ERC MSG_WIN ON
ERC PRG_WIN ON

ERC TRACK ON
ERC TRACK_TYPE X_DIRECTION 0.1
ERC COLOR TRACK  ALTERNATE

LABEL Collision
!
!-------------------------------------
! Move until COLLISION
!
! Move the robot down until the robot 
! is 0.1 mm above the cylinders surface
!
dx_min = 0.1 * mm2m
!
! Disable interpolation causes the robot 
! to jump to the taregt location
!
WAIT    5
ERC INTERPOLATION OFF
ERC TRACK OFF
CALL move_until_collision()
WAIT    5

ERC INTERPOLATION ON
Home 1
ERC TRACK ON
CALL move_until_collision()
WAIT    5

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! ENDE
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LABEL ende

msg >>> Program If_While_Goto_Label Done

EndProgramFile

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~

FCT move_until_collision()
!
iter = 0
iter_max = 100
dx = 200*mm2m
not_done = true
prev_coll = false
coll = false

ERC COLLISION QUEUE BODY_BODY OFF
ERC COLLISION ON

msg ---------------------------
msg --- Start While Loop ---
msg ---------------------------

while not_done

msg --- Go for next ---

iter = iter + 1

LIN_REL 0 0 dx 0 0 0
coll = collision()

if coll
   if prev_coll
      msg coll & prev_coll
   else
      dx = -dx/2
   endif
else
   if prev_coll
      dx = -dx/2
   else
      IF lt(dx,0)
         dx = -dx
      ENDIF
   endif
endif

prev_coll = coll

if gt(iter,iter_max)
   not_done = false
   MSG Error, reach max Iterations
else
   If bool(coll,false)
      If bool(prev_coll,false)
         if lt(abs(dx),dx_min)
            not_done = false
         endif
         msg if !prev_coll
      endif
   endif
endif

endwhile

IF lt(dx,0)
   dx = -dx
ENDIF
LIN_REL 0 0 dx 0 0 0

ERC COLLISION OFF

msg print out tcp z-value and number of ierations
=msg( (tcpz()-0.5)*m2mm )
=msg(iter)

!calc who()
!calc who_user()

ENDFCT


! END PRGFILE  173142020
